Attribute VB_Name = "Encryption"
Declare Sub SSInit Lib "sasme" (SSEncrTable As SStable)
Declare Function SSEncrypt Lib "sasme" (SSEncrTable As SStable, StrToEncr As String, ByVal StartPos As Integer) As Long
Declare Function SSDecrypt Lib "sasme" (SSEncrTable As SStable, StrToDecr As String, ByVal StartPos As Integer) As Long
Declare Function SSPingValue Lib "sasme" () As Long
Declare Sub SSRandomize Lib "sasme" (ByVal Seed As Long)
Declare Function SSRnd Lib "sasme" () As Integer
Declare Function SSKey01 Lib "sasme" () As Long
Declare Function SSProc1 Lib "sasme" () As Long
Declare Sub SSProc2 Lib "sasme" (Packet03 As String)

Type SStable
    SSKey           As Long
    SSBuf(1 To 520) As Byte
End Type

Public Sub InitEncryption(BotID As Integer, key As Long)
    Dim I As Integer

    With BotList(BotID)
        .SSEncrKey = key Xor .SSEncrKey 'Used only for comparison below.
        For I = 1 To 520                'I'm too lazy to check if this is necessary.
            .SSEncrTable.SSBuf(I) = 0
        Next
        .SSEncrTable.SSKey = key
        Call SSInit(.SSEncrTable)
    End With
End Sub

Public Sub Encrypt(BotID As Integer, packet As String)
    If BotList(BotID).SSEncrKey = 0 Then Exit Sub

    If Left(packet, 1) = Chr(0) Then
        Call SSEncrypt(BotList(BotID).SSEncrTable, packet, 3)
    Else
        Call SSEncrypt(BotList(BotID).SSEncrTable, packet, 2)
    End If
End Sub

Public Sub Decrypt(BotID As Integer, packet As String)
    If BotList(BotID).SSEncrKey = 0 Then Exit Sub

    If Left(packet, 1) = Chr(0) Then
        Call SSDecrypt(BotList(BotID).SSEncrTable, packet, 3)
    Else
        Call SSDecrypt(BotList(BotID).SSEncrTable, packet, 2)
    End If
End Sub
